//---------------------------------------------------------------------------
#ifndef Moochos_Execian_AppsMan_H
#define Moochos_Execian_AppsMan_H
//---------------------------------------------------------------------------
// AppsMan.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "ExecFiles.h"
//---------------------------------------------------------------------------
namespace Moochos { namespace Execian { namespace AppsMan {
//---------------------------------------------------------------------------
class EAppsManError : public Exception
{
public:
	__fastcall EAppsManError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TAppsMan : public TObject
{
private:
	TComboBox* FControl;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall Clear();
	void __fastcall LoadItems(TList* AItems);
	void __fastcall Execute(const AnsiString& AVerb, const AnsiString& AFileName);
	void __fastcall EnsureEntryDirExists();
	TExecApp* __fastcall GetItem(int AIndex);
	TExecApp* __fastcall GetSelectedItem();
	int __fastcall GetCount();
protected:
public:
	__fastcall TAppsMan(TComboBox* AControl);
	virtual __fastcall ~TAppsMan();
	void __fastcall Organize();
	void __fastcall Update();
	void __fastcall Open();
	void __fastcall OpenDirectory();
	void __fastcall ShowProperties();
	__property TComboBox* Control = {read=FControl};
	__property TExecApp* Items[int AIndex] = {read=GetItem};
	__property int Count = {read=GetCount};
};
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Execian::AppsMan
using namespace Moochos::Execian::AppsMan;
//---------------------------------------------------------------------------
#endif

