//---------------------------------------------------------------------------
#ifndef Moochos_Execian_DocsMan_H
#define Moochos_Execian_DocsMan_H
//---------------------------------------------------------------------------
// DocsMan.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <FileCtrl.hpp>
#include "ExecFiles.h"
//---------------------------------------------------------------------------
namespace Moochos { namespace Execian { namespace DocsMan {
//---------------------------------------------------------------------------
class EDocsManError : public Exception
{
public:
	__fastcall EDocsManError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TDocsMan : public TObject
{
private:
	TListView* FControl;
	TObjectList* FItemList;
	TOpenDialog* FAddFilesDialog;
	TOpenDialog* FImportDialog;
	TSaveDialog* FExportDialog;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall AddFiles(TStrings* AFiles);
	void __fastcall AddItems(TList* AItems);
	void __fastcall ReorderItems(const TIntegerDynArray& AOrder);
	TExecDoc* __fastcall GetItem(int AIndex);
	int __fastcall GetCount();
	AnsiString __fastcall QualifyFileName(const AnsiString& AFileName) const;
	int __fastcall CountElements(const TBooleanDynArray& AArray, bool AValue) const;
	__property TObjectList* ItemList = {read=FItemList};
protected:
public:
	__fastcall TDocsMan(TListView* AControl);
	virtual __fastcall ~TDocsMan();
	void __fastcall AddFiles();
	void __fastcall AddDirectory();
	void __fastcall AddDroppedFiles(TStrings* AFiles);
	void __fastcall RemoveSelected(bool AConfirm);
	void __fastcall RemoveByResult(TExecDocResult AResult, bool AConfirm);
	void __fastcall Remove(const TBooleanDynArray& ACanRemove, bool AConfirm);
	void __fastcall Clear(bool AConfirm);
	void __fastcall Import();
	void __fastcall Export();
	void __fastcall Cut();
	void __fastcall Copy();
	void __fastcall Paste();
	void __fastcall SelectAll();
	void __fastcall SelectByResult(TExecDocResult AResult);
	void __fastcall ReverseSelection();
	void __fastcall MoveUp();
	void __fastcall MoveDown();
	void __fastcall SortByName();
	void __fastcall SortByDirectory();
	void __fastcall SortByDirAndName();
	void __fastcall SortByResult();
	void __fastcall SortByError();
	void __fastcall Invert();
	void __fastcall ShowResults();
	int __fastcall CountResults(TExecDocResult AResult);
	__property TListView* Control = {read=FControl};
	__property TExecDoc* Items[int AIndex] = {read=GetItem};
	__property int Count = {read=GetCount};
	__property TOpenDialog* AddFilesDialog = {read=FAddFilesDialog};
	__property TOpenDialog* ImportDialog = {read=FImportDialog};
	__property TSaveDialog* ExportDialog = {read=FExportDialog};
};
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Execian::
using namespace Moochos::Execian::DocsMan;
//---------------------------------------------------------------------------
#endif

