//---------------------------------------------------------------------------
#ifndef Moochos_Execian_ExecFiles_H
#define Moochos_Execian_ExecFiles_H
//---------------------------------------------------------------------------
// ExecFiles.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Execian { namespace ExecFiles {
//---------------------------------------------------------------------------
class EExecFileError : public Exception
{
public:
	__fastcall EExecFileError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TExecApp : public TObject
{
private:
	TIcon* FIcon;
	AnsiString FTitle;
	AnsiString FFileName;
	AnsiString FWorkingDir;
	int FWindowState;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall Derefer(const AnsiString& AFileName);
	void __fastcall DereferIcon(const AnsiString& AFileName, TIcon* AIcon) const;
protected:
public:
	__fastcall TExecApp();
	__fastcall TExecApp(const AnsiString& AShortcutFile);
	virtual __fastcall ~TExecApp();
	void __fastcall Assign(TExecApp* AOther);
	__property TIcon* Icon = {read=FIcon};
	__property AnsiString Title = {read=FTitle, write=FTitle};
	__property AnsiString FileName = {read=FFileName, write=FFileName};
	__property AnsiString WorkingDir = {read=FWorkingDir, write=FWorkingDir};
	__property int WindowState = {read=FWindowState, write=FWindowState};
};
//---------------------------------------------------------------------------
enum TExecDocResult
{
	drNoResult,
	drSuccess,
	drFailure,
};
//---------------------------------------------------------------------------
enum TExecDocError
{
	deNoError,
	deFileNotFound,
	deFileNameNotFound,
	deDdeFailed,
	deNoAccociation,
	deAccessDenied,
	deDllNotFound,
	deCanceled,
	deNotEnoughMemory,
	deSharingViolation,
	deUnknown,
};
//---------------------------------------------------------------------------
class TExecDoc : public TObject
{
private:
	AnsiString FFileName;
	AnsiString FName;
	AnsiString FDirectory;
	TExecDocResult FResult;
	TExecDocError FError;
	void __fastcall SetFileName(const AnsiString& AFileName);
protected:
public:
	__fastcall TExecDoc();
	__fastcall TExecDoc(const AnsiString& AFileName);
	virtual __fastcall ~TExecDoc();
	void __fastcall Assign(TExecDoc* AOther);
	__property AnsiString FileName = {read=FFileName, write=SetFileName};
	__property AnsiString Name = {read=FName};
	__property AnsiString Directory = {read=FDirectory};
	__property TExecDocResult Result = {read=FResult, write=FResult};
	__property TExecDocError Error = {read=FError, write=FError};
};
//---------------------------------------------------------------------------
extern AnsiString __fastcall ExecDocResultToStr(TExecDocResult AResult);
extern AnsiString __fastcall ExecDocErrorToStr(TExecDocError AError);
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Execian::ExecFiles
using namespace Moochos::Execian::ExecFiles;
//---------------------------------------------------------------------------
#endif

