//---------------------------------------------------------------------------
#ifndef Moochos_Execian_ExecutionMan_H
#define Moochos_Execian_ExecutionMan_H
//---------------------------------------------------------------------------
// ExecutionMan.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
namespace Moochos { namespace Execian { namespace ExecTask { class TExecTask; }}} using namespace Moochos::Execian::ExecTask;
//---------------------------------------------------------------------------
namespace Moochos { namespace Execian { namespace ExecutionMan {
//---------------------------------------------------------------------------
class TExecutionMan : public TObject
{
private:
	TExecTask* FTask;
	bool FCanceling;
	TListView* FDocsControl;
	void __fastcall HandleMessages();
	void __fastcall HandleCanceling();
	void __fastcall HandleResults();
	void __fastcall TaskStart(TObject* ASender);
	void __fastcall TaskEnd(TObject* ASender);
	void __fastcall TaskCancel(TObject* ASender);
	void __fastcall TaskProgress(TObject* ASender);
	void __fastcall TaskIdle(TObject* ASender);
	void __fastcall TaskException(TObject* ASender, Exception* AException);
	void __fastcall TaskSkipWait(TObject* ASender);
	void __fastcall TaskPause(TObject* ASender);
	void __fastcall TaskResume(TObject* ASender);
	void __fastcall TaskAllReset(TObject* ASender);
	void __fastcall TaskOneExecute(TObject* ASender);
	void __fastcall TaskOneResult(TObject* ASender);
	void __fastcall TaskOneWait(TObject* ASender);
	void __fastcall TaskOneWaitFail(TObject* ASender);  
	void __fastcall ProgressDialogStart(TObject* ASender);
	void __fastcall ProgressDialogEnd(TObject* ASender);
	void __fastcall ProgressDialogExecute(TObject* ASender);
	void __fastcall ProgressDialogUnmark(TObject* ASender);
	void __fastcall ProgressDialogSkipWait(TObject* ASender);
	void __fastcall ProgressDialogPause(TObject* ASender);
	void __fastcall ProgressDialogResume(TObject* ASender);
	void __fastcall ProgressDialogCancel(TObject* ASender);
	__property TExecTask* Task = {read=FTask};
	__property bool Canceling = {read=FCanceling};
protected:
public:
	__fastcall TExecutionMan(TListView* ADocsControl);
	virtual __fastcall ~TExecutionMan();
	void __fastcall Execute(TExecApp* AApp, DynamicArray<TExecDoc*> ADocs);
	__property TListView* DocsControl = {read=FDocsControl};
};
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Execian:ExecutionMan:
using namespace Moochos::Execian::ExecutionMan;
//---------------------------------------------------------------------------
#endif

