//---------------------------------------------------------------------------
#ifndef Moochos_Moa_Lists_H
#define Moochos_Moa_Lists_H
//---------------------------------------------------------------------------
// Lists.h
//
// Version: 1.1.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Lists {
//---------------------------------------------------------------------------
// TList
//---------------------------------------------------------------------------
extern void __fastcall AddItems(TList* ASrcList, TList* ADstList);
extern void __fastcall Invert(TList* AList);
//---------------------------------------------------------------------------
// TObjectList
//---------------------------------------------------------------------------
class TAutoObjectListOwnsObjects
	// Temporarily changes OwnsObject of a TObjectList object until this
	// object is freed.
{
private:
	TObjectList* FList;
	bool FOwnsObjects;
	__fastcall TAutoObjectListOwnsObjects(const TAutoObjectListOwnsObjects& AOther); // Forbedden
	TAutoObjectListOwnsObjects& __fastcall operator =(const TAutoObjectListOwnsObjects& AOther); // Forbedden
protected:
public:
	__fastcall TAutoObjectListOwnsObjects(TObjectList* AList, bool AOwnsObjects);
	__fastcall ~TAutoObjectListOwnsObjects();
};
//---------------------------------------------------------------------------
// TStrings
//---------------------------------------------------------------------------
class TAutoStringsUpdate
	// Calls BeginUpdate on construction and EndUpdate on destruction.
{
private:
	TStrings* FList;
	__fastcall TAutoStringsUpdate(const TAutoStringsUpdate& AOther); // Forbedden
	TAutoStringsUpdate& __fastcall operator =(const TAutoStringsUpdate& AOther); // Forbedden
protected:
public:
	__fastcall TAutoStringsUpdate(TStrings* AList);
	__fastcall ~TAutoStringsUpdate();
};
//---------------------------------------------------------------------------
extern void __fastcall PackByString(TStrings* ASrcList, TStrings* ADstList);
extern void __fastcall PackByObject(TStrings* ASrcList, TStrings* ADstList);
extern void __fastcall PackBy(TStrings* ASrcList, TStrings* ADstList, bool __fastcall (* ACanDeleteProc)(TStrings* AList, int AIndex, void* AData), void* AData);
extern void __fastcall Invert(TStrings* AList);
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Moa::Lists
using namespace Moochos::Moa::Lists;
//---------------------------------------------------------------------------
#endif

