//---------------------------------------------------------------------------
#ifndef Moochos_Moa_Sync_H
#define Moochos_Moa_Sync_H
//---------------------------------------------------------------------------
// Sync.h
//
// Version: 1.1.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Sync {
//---------------------------------------------------------------------------
class ELockError : public Exception
{
public:
	__fastcall ELockError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class ELockFailure : public Exception
{
public:
	__fastcall ELockFailure(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TMutex
	// Represents a mutex object. Create a mutex object following the naming
	// rules of Windows.
{
private:
	HANDLE FHandle;
	bool FLocked;
	__fastcall TMutex(const TMutex& AOther); // Forbidden
	TMutex& __fastcall operator =(const TMutex& AOther); // Forbidden
protected:
public:
	__fastcall TMutex(const AnsiString& AName, bool ATryLockNow);
	__fastcall ~TMutex();
	void __fastcall Lock(int ATimeoutInterval = -1);
	bool __fastcall TryLock(int ATimeoutInterval = -1);
	void __fastcall Unlock();
	bool __fastcall IsLocked();
	__property HANDLE Handle = {read=FHandle};
};
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Moa::Sync
using namespace Moochos::Moa::Sync;
//---------------------------------------------------------------------------
#endif

