//---------------------------------------------------------------------------
// MainFormUnit.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <mbstring.h>
#include <Clipbrd.hpp>
#include <Math.hpp>
#include <UtilCls.h>
#include "Lib/Moochos/Moa/Clipboard.h"
#include "Lib/Moochos/Moa/Controls2.h"
#include "Lib/Moochos/Moa/Forms.h"
#include "Lib/Moochos/Moa/ListControls.h"
#include "Lib/Moochos/Moa/Shell.h"
#include "MainFormUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm* MainForm = NULL;
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(DocsMan->CountResults(drSuccess) != DocsMan->Count) {
		if(Application->MessageBox(
			"Not all documents are in success.\r\n\r\nQuit the application?",
			Application->Title.c_str(),
			MB_YESNO | MB_ICONWARNING | MB_SETFOREGROUND) != IDYES) {
			ACanClose = false;
			return;
		}
	}
	try {
		SettingsMan->Save();
	}
	catch(ESettingsManError& e) {
		Application->ShowException(&e);
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AppsOrganizeAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	AppsMan->Organize();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AppsUpdateAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	AppsMan->Update();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AppsOpenAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	AppsMan->Open();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AppsOpenDirectoryAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	AppsMan->OpenDirectory();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AppsPropertiesAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	AppsMan->ShowProperties();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsAddFilesAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->AddFiles();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsAddDirectoryAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->AddDirectory();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsAddDroppedFilesAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->AddDroppedFiles(DroppedFiles);
	DroppedFiles->Clear();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsRemoveSelectedAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->RemoveSelected(true);
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsRemoveSuccessAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->RemoveByResult(drSuccess, false);
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsClearAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->Clear(DocsMan->CountResults(drSuccess) != DocsMan->Count);
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsImportAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->Import();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsExportAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->Export();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsCutAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->Cut();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsCopyAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->Copy();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsPasteAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->Paste();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsSelectAllAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->SelectAll();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsSelectNoResultAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->SelectByResult(drNoResult);
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsSelectSuccessAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->SelectByResult(drSuccess);
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsSelectFailureAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->SelectByResult(drFailure);
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsReverseSelectionAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->ReverseSelection();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsMoveUpAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->MoveUp();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsMoveDownAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->MoveDown();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsSortByDirectoryAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->SortByDirectory();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsSortByNameAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->SortByName();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsSortByDirAndNameAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->SortByDirAndName();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsSortByResultAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->SortByResult();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsSortByErrorAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->SortByError();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsInvertAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->Invert();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DocsResultsAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	DocsMan->ShowResults();
	UpdateDocsStatus();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ExecutionExecuteAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	TAutoControlVisible autoControlVisible(this, !HideOnExecute);
	TAutoControlEnabled autoControlEnabled(this, HideOnExecute ? false : Enabled);
	ExecutionMan->Execute(UseApp ? App : NULL, Docs);
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ViewHideOnExecuteAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpContentsAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	HelpMan->ShowContents(true);
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpAboutAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	HelpMan->ShowAbout();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ActionList91Execute(TBasicAction* AAction, bool& AHandled)
{
	TContainedAction* action = dynamic_cast<TContainedAction*>(AAction);
	if(action->Category == AppsOrganizeAc->Category) {
		ActiveControl = AppsMan->Control;
	}
	else if(action->Category == DocsAddFilesAc->Category) {
		ActiveControl = DocsMan->Control;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ActionList91Update(TBasicAction* AAction, bool& AHandled)
{
	AHandled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CheckBox11Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ComboBox11Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ComboBox11DrawItem(TWinControl* AControl, int AIndex, TRect& ARect, TOwnerDrawState AState)
{
	if(AIndex < 0 || AIndex > AppsMan->Count - 1 || AppsMan->Items[AIndex] == NULL) {
		ComboBox11->Canvas->FillRect(ARect);
		return;
	}

	// Draw text
	{
		if(!ComboBox11->Enabled) {
			ComboBox11->Canvas->Font->Color = clGrayText;
		}
		TRect textBounds = ListItemLayout->CalculateTextBounds(ARect);
		ComboBox11->Canvas->TextRect(
			ARect,
			textBounds.left,
			textBounds.top,
			ComboBox11->Items->Strings[AIndex]);
	}

	// Draw an icon
	{
		TRect iconBounds = ListItemLayout->CalculateIconBounds(ARect);
		DrawState(
			ComboBox11->Canvas->Handle,
			NULL,
			NULL,
			reinterpret_cast<LPARAM>(AppsMan->Items[AIndex]->Icon->Handle),
			NULL,
			iconBounds.left,
			iconBounds.top,
			iconBounds.Width(),
			iconBounds.Height(),
			DST_ICON | (AControl->Enabled ? 0 : DSS_DISABLED));
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ListView21ColumnClick(TObject* ASender, TListColumn* AColumn)
{
	switch(AColumn->Index) {
	case 0:
		DocsSortByNameAc->Execute();  
		break;
	case 1:
		DocsSortByDirectoryAc->Execute();
		break;
	case 2:
		DocsSortByResultAc->Execute();
		break;
	case 3:
		DocsSortByErrorAc->Execute();
		break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ListView21Data(TObject* ASender, TListItem* AItem)
{
	int index = AItem->Index;
	if(index < 0 || index > DocsMan->Count - 1 || DocsMan->Items[index] == NULL) {
		return;
	}
	TExecDoc* doc = DocsMan->Items[index];
	AItem->Caption = doc->Name;
	AItem->SubItems->Capacity = 3;
	AItem->SubItems->Add(doc->Directory);
	AItem->SubItems->Add(ExecDocResultToStr(doc->Result));
	AItem->SubItems->Add(ExecDocErrorToStr(doc->Error));
	AItem->Data = doc;
	switch(doc->Result) {
	case drNoResult:
		AItem->ImageIndex = 0;
		break;
	case drSuccess:
		AItem->ImageIndex = 1;
		break;
	case drFailure:
		AItem->ImageIndex = 2;
		break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ListView21DataFind(TObject* ASender, TItemFind AFind, const AnsiString AFindString, const TPoint& AFindPosition, Pointer AFindData, int AStartIndex, TSearchDirection ADirection, bool AWrap, int& AIndex)
{
	// Warning: Typing keys calls this handler with ifExactString instead of
	// ifPartialString. This handler ignores the difference between them. Do
	// not call TListView::FindCaption because it does not work properly on
	// this program.

	if(ADirection != sdAll) {
		return;
	}
	int itemCount = ListView21->Items->Count;
	int itemIndex = AStartIndex - 1;
	for(int i = 0; i < itemCount; i++) {
		if(itemIndex == itemCount - 1 && !AWrap) {
			return;
		}
		itemIndex = (itemIndex + 1) % itemCount;
		switch(AFind) {
		case ifPartialString:
		case ifExactString:
			if(_mbsnicmp(
				ListView21->Items->Item[itemIndex]->Caption.c_str(),
				AFindString.c_str(),
				AFindString.Length()) != 0) {
				continue;
			}
			break;
		case ifData:
			if(ListView21->Items->Item[itemIndex]->Data != AFindData) {
				continue;
			}
			break;
		default:
			return;
		}
		AIndex = itemIndex;
		return;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ListView21SelectItem(TObject* ASender, TListItem* AItem, bool ASelected)
{
	UpdateAccessExecutor->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::PopupMenu11Popup(TObject* ASender)
{
	ActiveControl = ComboBox11;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::PopupMenu21Popup(TObject* ASender)
{
	ActiveControl = ListView21;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Initialize()
{
	try {
		// Lay out controls properly in any font size
		BorderStyle = bsSizeable;

		Application->OnIdle = ApplicationIdle;
		DragAcceptFiles(Handle, true);

		FAppsMan = new TAppsMan(ComboBox11);
		FDocsMan = new TDocsMan(ListView21);
		FExecutionMan = new TExecutionMan(ListView21);
		FHelpMan = new THelpMan();
		FSettingsMan = new TSettingsMan();

		FDroppedFiles = new TStringList();
		static_cast<TStringList*>(DroppedFiles)->OnChange = DroppedFilesChange;

		FClipboardWatcher = new TClipboardWatcher();
		ClipboardWatcher->Enabled = true;
		ClipboardWatcher->OnChange = ClipboardWatcherChange;

		FListItemLayout = new TListItemLayout();
		ListItemLayout->HorzPadding = 1;
		ListItemLayout->VertPadding = 1;
		ListItemLayout->IconWidth = 16;
		ListItemLayout->IconHeight = 16;
		ListItemLayout->TextHeight = ComboBox11->Canvas->TextHeight('A');
		ComboBox11->ItemHeight = ListItemLayout->ItemHeight;

		FUpdateAccessExecutor = new TLateExecutor();
		UpdateAccessExecutor->OnExecute = UpdateAccessExecutorExecute;

		AppsMan->Update();
		HideOnExecute = true;
		UpdateAccess();
		UpdateDocsStatus();
		SettingsMan->Load();
	}
	catch(ESettingsManError& e) {
		SettingsMan->DeleteFile(false);
		Uninitialize();
		throw;
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Uninitialize()
{
	delete FUpdateAccessExecutor;
	FUpdateAccessExecutor = NULL;

	delete FListItemLayout;
	FListItemLayout = NULL;

	delete FClipboardWatcher;
	FClipboardWatcher = NULL;

	delete FDroppedFiles;
	FDroppedFiles = NULL;

	delete FSettingsMan;
	FSettingsMan = NULL;

	delete FHelpMan;
	FHelpMan = NULL;

	delete FExecutionMan;
	FExecutionMan = NULL;

	delete FDocsMan;
	FDocsMan = NULL;

	delete FAppsMan;
	FAppsMan = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ProcessParams()
{
	if(ParamCount() == 0) {
		return;
	}
	TPtr<TStrings> files = new TStringList();
	files->Capacity = ParamCount();
	for(int i = 0; i < ParamCount(); i++) {
		files->Add(ParamStr(i + 1));
	}
	DroppedFiles->Assign(files);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMDropFiles(TMessage& AMessage)
{
	TFileDrop fileDrop(AMessage);

	TAutoScreenCursor autoScreenCursor(crHourGlass);
	SetForegroundWindow(Handle);
	TPtr<TStrings> files = new TStringList();
	fileDrop.GetFiles(files);
	fileDrop.Finish();
	DroppedFiles->Assign(files);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ApplicationIdle(TObject* ASender, bool& ADone)
{
	Application->OnIdle = NULL;
	ProcessParams();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DroppedFilesChange(TObject* ASender)
{
	if(DroppedFiles->Count == 0) {
		return;
	}
	DocsAddDroppedFilesAc->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ClipboardWatcherChange(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateAccessExecutorExecute(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
TExecApp* __fastcall TMainForm::GetApp()
{
	return AppsMan->Items[AppsMan->Control->ItemIndex];
}
//---------------------------------------------------------------------------
DynamicArray<TExecDoc*> __fastcall TMainForm::GetDocs()
{
	DynamicArray<TExecDoc*> docs;
	docs.Length = DocsMan->Count;
	for(int i = 0; i < DocsMan->Count; i++) {
		docs[i] = DocsMan->Items[i];
	}
	return docs;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::GetUseApp()
{
	return CheckBox11->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetUseApp(bool AUseApp)
{
	CheckBox11->Checked = AUseApp;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::GetHideOnExecute()
{
	return ViewHideOnExecuteAc->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetHideOnExecute(bool AHideOnExecute)
{
	ViewHideOnExecuteAc->Checked = AHideOnExecute;
}
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* AOwner) :
	TForm(AOwner),
	FAppsMan(NULL),
	FDocsMan(NULL),
	FExecutionMan(NULL),
	FHelpMan(NULL),
	FSettingsMan(NULL),
	FDroppedFiles(NULL),
	FClipboardWatcher(NULL),
	FListItemLayout(NULL),
	FUpdateAccessExecutor(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TMainForm::~TMainForm()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateAccess()
{
	bool appEnabled = UseApp;
	bool appSelected = AppsMan->Control->ItemIndex >= 0;
	AppsOrganizeAc->Enabled = appEnabled;
	AppsUpdateAc->Enabled = appEnabled;
	AppsOpenAc->Enabled = appEnabled && appSelected;
	AppsOpenDirectoryAc->Enabled = appEnabled && appSelected;
	AppsPropertiesAc->Enabled = appEnabled && appSelected;
	AppsMan->Control->Enabled = appEnabled;

	bool docsNotEmpty = DocsMan->Count > 0;
	bool docsEnabled = DocsMan->Control->Enabled;
	bool docsSelected = DocsMan->Control->SelCount > 0;
	DocsAddFilesAc->Enabled = docsEnabled;
	DocsAddDirectoryAc->Enabled = docsEnabled;
	DocsRemoveSelectedAc->Enabled = docsEnabled && docsSelected;
	DocsRemoveSuccessAc->Enabled = docsEnabled && docsNotEmpty;
	DocsClearAc->Enabled = docsEnabled && docsNotEmpty;
	DocsImportAc->Enabled = docsEnabled;
	DocsExportAc->Enabled = docsEnabled && docsSelected;
	DocsCutAc->Enabled = docsEnabled && docsSelected;
	DocsCopyAc->Enabled = docsEnabled && docsSelected;
	DocsPasteAc->Enabled = docsEnabled && Clipboard()->HasFormat(CF_TEXT);
	DocsSelectAllAc->Enabled = docsEnabled && docsNotEmpty;
	DocsSelectNoResultAc->Enabled = docsEnabled && docsNotEmpty;
	DocsSelectSuccessAc->Enabled = docsEnabled && docsNotEmpty;
	DocsSelectFailureAc->Enabled = docsEnabled && docsNotEmpty;
	DocsReverseSelectionAc->Enabled = docsEnabled && docsNotEmpty;
	DocsMoveUpAc->Enabled = docsEnabled && docsSelected;
	DocsMoveDownAc->Enabled = docsEnabled && docsSelected;
	DocsSortByDirectoryAc->Enabled = docsEnabled && docsNotEmpty;
	DocsSortByNameAc->Enabled = docsEnabled && docsNotEmpty;
	DocsSortByDirAndNameAc->Enabled = docsEnabled && docsNotEmpty;
	DocsSortByResultAc->Enabled = docsEnabled && docsNotEmpty;
	DocsSortByErrorAc->Enabled = docsEnabled && docsNotEmpty;
	DocsInvertAc->Enabled = docsEnabled && docsNotEmpty;
	DocsResultsAc->Enabled = docsEnabled;

	ExecutionExecuteAc->Enabled = ((appEnabled && appSelected) || !appEnabled) && docsNotEmpty;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateDocsStatus()
{
	Label21->Caption = AnsiString().sprintf("%d items", DocsMan->Count);
}
//---------------------------------------------------------------------------

