//---------------------------------------------------------------------------
#ifndef Moochos_Execian_MainFormUnit_H
#define Moochos_Execian_MainFormUnit_H
//---------------------------------------------------------------------------
// MainFormUnit.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <ActnList.hpp>
#include <Buttons.hpp>
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <FileCtrl.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <StdCtrls.hpp>
#include "AppsMan.h"
#include "DocsMan.h"
#include "ExecutionMan.h"
#include "HelpMan.h"
#include "SettingsMan.h"
namespace Moochos { namespace Moa { namespace Clipboard { class TClipboardWatcher; }}} using namespace Moochos::Moa::Clipboard;
namespace Moochos { namespace Moa { namespace ListControls { class TListItemLayout; }}} using namespace Moochos::Moa::ListControls;
namespace Moochos { namespace Moa { namespace Controls2 { class TLateExecutor; }}} using namespace Moochos::Moa::Controls2;
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace MainFormUnit {
//---------------------------------------------------------------------------
class EMainFormError : public Exception
{
public:
	__fastcall EMainFormError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Moa::MainFormUnit
using namespace Moochos::Moa::MainFormUnit;
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	TAction* AppsOrganizeAc;
	TAction* AppsUpdateAc;
	TAction* AppsOpenAc;
	TAction* AppsOpenDirectoryAc;
	TAction* AppsPropertiesAc;
	TAction* DocsAddFilesAc;
	TAction* DocsAddDirectoryAc;
	TAction* DocsAddDroppedFilesAc;
	TAction* DocsRemoveSelectedAc;
	TAction* DocsRemoveSuccessAc;
	TAction* DocsClearAc;
	TAction* DocsImportAc;
	TAction* DocsExportAc;
	TAction* DocsCutAc;
	TAction* DocsCopyAc;
	TAction* DocsPasteAc;
	TAction* DocsSelectAllAc;
	TAction* DocsSelectNoResultAc;
	TAction* DocsSelectSuccessAc;
	TAction* DocsSelectFailureAc;
	TAction* DocsReverseSelectionAc;
	TAction* DocsMoveUpAc;
	TAction* DocsMoveDownAc;
	TAction* DocsSortByDirectoryAc;
	TAction* DocsSortByNameAc;
	TAction* DocsSortByDirAndNameAc;
	TAction* DocsSortByResultAc;
	TAction* DocsSortByErrorAc;
	TAction* DocsInvertAc;
	TAction* DocsResultsAc;
	TAction* ExecutionExecuteAc;
	TAction* ViewHideOnExecuteAc;
	TAction* HelpContentsAc;
	TAction* HelpAboutAc;
	TActionList* ActionList91;
	TButton* Button91;
	TCheckBox* CheckBox11;
	TComboBox* ComboBox11;
	TGroupBox* GroupBox91;
	TGroupBox* GroupBox92;
	TImageList* ImageList21;
	TLabel* Label21;
	TListView* ListView21;
	TMenuItem* MenuItem11;
	TMenuItem* MenuItem12;
	TMenuItem* MenuItem13;
	TMenuItem* MenuItem14;
	TMenuItem* MenuItem15;
	TMenuItem* MenuItem16;
	TMenuItem* MenuItem21;
	TMenuItem* MenuItem211;
	TMenuItem* MenuItem212;
	TMenuItem* MenuItem22;
	TMenuItem* MenuItem221;
	TMenuItem* MenuItem222;
	TMenuItem* MenuItem223;
	TMenuItem* MenuItem23;
	TMenuItem* MenuItem24;
	TMenuItem* MenuItem241;
	TMenuItem* MenuItem242;
	TMenuItem* MenuItem25;
	TMenuItem* MenuItem26;
	TMenuItem* MenuItem27;
	TMenuItem* MenuItem28;
	TMenuItem* MenuItem281;
	TMenuItem* MenuItem282;
	TMenuItem* MenuItem283;
	TMenuItem* MenuItem284;
	TMenuItem* MenuItem285;
	TMenuItem* MenuItem286;
	TMenuItem* MenuItem287;
	TMenuItem* MenuItem29;
	TMenuItem* MenuItem2A;
	TMenuItem* MenuItem2A1;
	TMenuItem* MenuItem2A2;
	TMenuItem* MenuItem2A3;
	TMenuItem* MenuItem2A4;
	TMenuItem* MenuItem2A5;
	TMenuItem* MenuItem2B;
	TMenuItem* MenuItem2C;
	TMenuItem* MenuItem2D;
	TMenuItem* MenuItem2E;
	TMenuItem* MenuItem2F;
	TMenuItem* MenuItem2G;
	TMenuItem* MenuItem91;
	TMenuItem* MenuItem92;
	TMenuItem* MenuItem93;
	TMenuItem* MenuItem931;
	TMenuItem* MenuItem932;
	TMenuItem* MenuItem933;
	TPopupMenu* PopupMenu11;
	TPopupMenu* PopupMenu21;
	TPopupMenu* PopupMenu91;
	TSpeedButton* SpeedButton21;
	TSpeedButton* SpeedButton22;
	TSpeedButton* SpeedButton23;
	TSpeedButton* SpeedButton24;
	TSpeedButton* SpeedButton25;
	TSpeedButton* SpeedButton26;
	TSpeedButton* SpeedButton27;
	TSpeedButton* SpeedButton28;
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall AppsOrganizeAcExecute(TObject* ASender);
	void __fastcall AppsUpdateAcExecute(TObject* ASender);
	void __fastcall AppsOpenAcExecute(TObject* ASender);
	void __fastcall AppsOpenDirectoryAcExecute(TObject* ASender);
	void __fastcall AppsPropertiesAcExecute(TObject* ASender);
	void __fastcall DocsAddFilesAcExecute(TObject* ASender);
	void __fastcall DocsAddDirectoryAcExecute(TObject* ASender);
	void __fastcall DocsAddDroppedFilesAcExecute(TObject* ASender);
	void __fastcall DocsRemoveSelectedAcExecute(TObject* ASender);
	void __fastcall DocsRemoveSuccessAcExecute(TObject* ASender);
	void __fastcall DocsClearAcExecute(TObject* ASender);
	void __fastcall DocsImportAcExecute(TObject* ASender);
	void __fastcall DocsExportAcExecute(TObject* ASender);
	void __fastcall DocsCutAcExecute(TObject* ASender);
	void __fastcall DocsCopyAcExecute(TObject* ASender);
	void __fastcall DocsPasteAcExecute(TObject* ASender);
	void __fastcall DocsSelectAllAcExecute(TObject* ASender);
	void __fastcall DocsSelectNoResultAcExecute(TObject* ASender);
	void __fastcall DocsSelectSuccessAcExecute(TObject* ASender);
	void __fastcall DocsSelectFailureAcExecute(TObject* ASender);
	void __fastcall DocsReverseSelectionAcExecute(TObject* ASender);
	void __fastcall DocsMoveUpAcExecute(TObject* ASender);
	void __fastcall DocsMoveDownAcExecute(TObject* ASender);
	void __fastcall DocsSortByDirectoryAcExecute(TObject* ASender);
	void __fastcall DocsSortByNameAcExecute(TObject* ASender);
	void __fastcall DocsSortByDirAndNameAcExecute(TObject* ASender);
	void __fastcall DocsSortByResultAcExecute(TObject* ASender);
	void __fastcall DocsSortByErrorAcExecute(TObject* ASender);
	void __fastcall DocsInvertAcExecute(TObject* ASender);
	void __fastcall DocsResultsAcExecute(TObject* ASender);
	void __fastcall ExecutionExecuteAcExecute(TObject* ASender);
	void __fastcall ViewHideOnExecuteAcExecute(TObject* ASender);
	void __fastcall HelpContentsAcExecute(TObject* ASender);
	void __fastcall HelpAboutAcExecute(TObject* ASender);
	void __fastcall ActionList91Execute(TBasicAction* AAction, bool& AHandled);
	void __fastcall ActionList91Update(TBasicAction* AAction, bool& AHandled);
	void __fastcall CheckBox11Click(TObject* ASender);
	void __fastcall ComboBox11Click(TObject* ASender);
	void __fastcall ComboBox11DrawItem(TWinControl* AControl, int AIndex, TRect& ARect, TOwnerDrawState AState);
	void __fastcall ListView21ColumnClick(TObject* ASender, TListColumn* AColumn);
	void __fastcall ListView21Data(TObject* ASender, TListItem* AItem);
	void __fastcall ListView21DataFind(TObject* ASender, TItemFind AFind, const AnsiString AFindString, const TPoint& AFindPosition, Pointer AFindData, int AStartIndex, TSearchDirection ADirection, bool AWrap, int& AIndex);
	void __fastcall ListView21SelectItem(TObject* ASender, TListItem* AItem, bool ASelected);
	void __fastcall PopupMenu11Popup(TObject* ASender);
	void __fastcall PopupMenu21Popup(TObject* ASender);
private:
	TAppsMan* FAppsMan;
	TDocsMan* FDocsMan;
	TExecutionMan* FExecutionMan;
	THelpMan* FHelpMan;
	TSettingsMan* FSettingsMan;
	TStrings* FDroppedFiles;
	TClipboardWatcher* FClipboardWatcher;
	TListItemLayout* FListItemLayout;
	TLateExecutor* FUpdateAccessExecutor;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall ProcessParams();
	void __fastcall WMDropFiles(TMessage& AMessage);
	void __fastcall ApplicationIdle(TObject* ASender, bool& ADone);
	void __fastcall DroppedFilesChange(TObject* ASender);
	void __fastcall ClipboardWatcherChange(TObject* ASender);
	void __fastcall UpdateAccessExecutorExecute(TObject* ASender);
	TExecApp* __fastcall GetApp();
	DynamicArray<TExecDoc*> __fastcall GetDocs();
	bool __fastcall GetUseApp();
	void __fastcall SetUseApp(bool AUseApp);
	bool __fastcall GetHideOnExecute();
	void __fastcall SetHideOnExecute(bool AHideOnExecute);
protected:
public:
	virtual __fastcall TMainForm(TComponent* AOwner);
	virtual __fastcall ~TMainForm();
	void __fastcall UpdateAccess();
	void __fastcall UpdateDocsStatus();
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_DROPFILES, TMessage, WMDropFiles)
	END_MESSAGE_MAP(TForm)
	__property TAppsMan* AppsMan = {read=FAppsMan};
	__property TDocsMan* DocsMan = {read=FDocsMan};
	__property TExecutionMan* ExecutionMan = {read=FExecutionMan};
	__property THelpMan* HelpMan = {read=FHelpMan};
	__property TSettingsMan* SettingsMan = {read=FSettingsMan};
	__property TStrings* DroppedFiles = {read=FDroppedFiles};
	__property TClipboardWatcher* ClipboardWatcher = {read=FClipboardWatcher};
	__property TListItemLayout* ListItemLayout = {read=FListItemLayout};
	__property TLateExecutor* UpdateAccessExecutor = {read=FUpdateAccessExecutor};
	__property TExecApp* App = {read=GetApp};
	__property DynamicArray<TExecDoc*> Docs = {read=GetDocs};
	__property bool UseApp = {read=GetUseApp, write=SetUseApp};
	__property bool HideOnExecute = {read=GetHideOnExecute, write=SetHideOnExecute};
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm* MainForm;
//---------------------------------------------------------------------------
#endif

