//---------------------------------------------------------------------------
#ifndef Moochos_Execian_ProgressDialogUnit_H
#define Moochos_Execian_ProgressDialogUnit_H
//---------------------------------------------------------------------------
// ProgressDialogUnit.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <FileCtrl.hpp>
#include <StdCtrls.hpp>
#include "ExecFiles.h"
//---------------------------------------------------------------------------
class EProgressDialogError : public Exception
{
public:
	__fastcall EProgressDialogError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TProgressDialog : public TForm
{
__published:
	TButton* Button91;
	TButton* Button92;
	TButton* Button93;
	TButton* Button94;
	TLabel* Label111;
	TLabel* Label112;
	TLabel* Label121;
	TLabel* Label122;
	TLabel* Label131;
	TLabel* Label132;
	TLabel* Label141;
	TLabel* Label142;
	TLabel* Label143;
	TProgressBar* ProgressBar11;
	void __fastcall Button91Click(TObject* ASender);
	void __fastcall Button92Click(TObject* ASender);
	void __fastcall Button93Click(TObject* ASender);
	void __fastcall Button94Click(TObject* ASender);
private:
	enum TState
	{
		stStarted,
		stEnded,
		stPaused,
	};
	typedef Set<TState, stStarted, stPaused> TStates;
	static const UINT WM_EXECUTE = WM_APP + 0;
	AnsiString FDocument;
	int FNoResult;
	int FSuccess;
	int FFailure;
	TStates FState;
	TNotifyEvent FOnStart;
	TNotifyEvent FOnEnd;
	TNotifyEvent FOnExecute;
	TNotifyEvent FOnUnmark;
	TNotifyEvent FOnSkipWait;
	TNotifyEvent FOnPause;
	TNotifyEvent FOnResume;
	TNotifyEvent FOnCancel;
	void __fastcall WMClose(TMessage& AMessage);
	void __fastcall WMExecute(TMessage& AMessage);
	void __fastcall DoStart();
	void __fastcall DoEnd();
	void __fastcall DoExecute();
	void __fastcall DoUnmark();
	void __fastcall DoSkipWait();
	void __fastcall DoPause();
	void __fastcall DoResume();
	void __fastcall DoCancel();
	AnsiString __fastcall GetApplication();
	void __fastcall SetApplication(const AnsiString& AApplication);
	void __fastcall SetDocument(const AnsiString& ADocument);
	AnsiString __fastcall GetStatus();
	void __fastcall SetStatus(const AnsiString& AStatus);
	int __fastcall GetProgress();
	void __fastcall SetProgress(int AProgress);
	void __fastcall SetNoResult(int ANoResult);
	void __fastcall SetSuccess(int ASuccess);
	void __fastcall SetFailure(int AFailure);
	int __fastcall GetResultValue(TExecDocResult AResult);
	void __fastcall SetResultValue(TExecDocResult AResult, int AResultValue);
	bool __fastcall GetStarted();
	bool __fastcall GetEnded();
	bool __fastcall GetPaused();
	void __fastcall SetState(const TStates& AState);
	void __fastcall UpdateAccess();
	__property TStates State = {read=FState, write=SetState};
protected:
public:
	virtual __fastcall TProgressDialog(TComponent* AOwner);
	virtual __fastcall ~TProgressDialog();
	void __fastcall Execute();
	void __fastcall Finish();
	void __fastcall ForceClose();
	void __fastcall Unmark();
	void __fastcall SkipWait();
	void __fastcall Pause();
	void __fastcall Resume();
	void __fastcall Cancel();
	bool __fastcall IsBusy();
	bool __fastcall IsCompleted();
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_CLOSE, TMessage, WMClose)
		MESSAGE_HANDLER(WM_EXECUTE, TMessage, WMExecute)
	END_MESSAGE_MAP(TForm)
	__property AnsiString Application = {read=GetApplication, write=SetApplication};
	__property AnsiString Document = {read=FDocument, write=SetDocument};
	__property AnsiString Status = {read=GetStatus, write=SetStatus};
	__property int Progress = {read=GetProgress, write=SetProgress};
	__property int NoResult = {read=FNoResult, write=SetNoResult};
	__property int Success = {read=FSuccess, write=SetSuccess};
	__property int Failure = {read=FFailure, write=SetFailure};
	__property int ResultValues[TExecDocResult AResult] = {read=GetResultValue, write=SetResultValue};
	__property bool Started = {read=GetStarted};
	__property bool Ended = {read=GetEnded};
	__property bool Paused = {read=GetPaused};
	__property TNotifyEvent OnStart = {read=FOnStart, write=FOnStart};
	__property TNotifyEvent OnEnd = {read=FOnEnd, write=FOnEnd};
	__property TNotifyEvent OnExecute = {read=FOnExecute, write=FOnExecute};
	__property TNotifyEvent OnUnmark = {read=FOnUnmark, write=FOnUnmark};
	__property TNotifyEvent OnSkipWait = {read=FOnSkipWait, write=FOnSkipWait};
	__property TNotifyEvent OnPause = {read=FOnPause, write=FOnPause};
	__property TNotifyEvent OnResume = {read=FOnResume, write=FOnResume};
	__property TNotifyEvent OnCancel = {read=FOnCancel, write=FOnCancel};
};
//---------------------------------------------------------------------------
extern PACKAGE TProgressDialog* ProgressDialog;
//---------------------------------------------------------------------------
#endif

